# Module alloc::heap [−] [src]

🔬 This is a nightly-only experimental API. (`heap_api` #27700)

the precise API and guarantees it provides may be tweaked slightly, especially to possibly take into account the types being stored to make room for a future tracing garbage collector

## Constants

EMPTY | [ Experimental ] An arbitrary non-null address to represent zero-size allocations.

## Functions

allocate⚠ | [ Experimental ] Return a pointer to `size` bytes of memory aligned to `align`.
deallocate⚠ | [ Experimental ] Deallocates the memory referenced by `ptr`.
reallocate⚠ | [ Experimental ] Resize the allocation referenced by `ptr` to `size` bytes.
reallocate_inplace⚠ | [ Experimental ] Resize the allocation referenced by `ptr` to `size` bytes.
usable_size | [ Experimental ] Returns the usable size of an allocation created with the specified the `size` and `align`.

# Help

## Keyboard Shortcuts

?
  Show this help dialog
S
  Focus the search field
⇤
  Move up in search results
⇥
  Move down in search results
⏎
  Go to active search result
+
  Collapse/expand all sections

## Search Tricks

Prefix searches with a type followed by a colon (e.g. `fn:`) to restrict the search to a given type.

Accepted types are: `fn`, `mod`, `struct`, `enum`, `trait`, `type`, `macro`, and `const`.

Search functions by type signature (e.g. `vec -> usize` or `* -> vec`)